using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Drawing.Imaging;

namespace TrtImage1
{
 public struct Pixel24Data
 {
  public byte blue;
  public byte green;
  public byte red;
 }
 public struct Pixel32Data
 {
  public byte blue;
  public byte green;
  public byte red;
  public byte A;
 }
 public partial class Form1 : Form
 {
  public Form1()
  {
   InitializeComponent();
  }

  private void Form1_Load(object sender, EventArgs e)
  {
   zaPerformance.Text = "";
  }

  Bitmap bmp;
  int BitsPerPixel;
  private void bLoad_Click(object sender, System.EventArgs e)
  {
   ofdImage.InitialDirectory = Directory.GetCurrentDirectory();
   DialogResult res = ofdImage.ShowDialog();
   if (res == DialogResult.OK)
   {
    try
    {
     bmp = new Bitmap(ofdImage.FileName);

     ClientSize = new Size(bmp.Size.Width, bmp.Size.Height + 80);
     PixelFormat pf = bmp.PixelFormat;
     switch (pf)
     {
      case PixelFormat.Format16bppArgb1555: BitsPerPixel = 16; break;
      case PixelFormat.Format16bppGrayScale: BitsPerPixel = 16; break;
      case PixelFormat.Format24bppRgb: BitsPerPixel = 24; break;
      case PixelFormat.Format32bppArgb: BitsPerPixel = 32; break;
      case PixelFormat.Format32bppPArgb: BitsPerPixel = 32; break;
      case PixelFormat.Format32bppRgb: BitsPerPixel = 32; break;
      default: BitsPerPixel = 8; break;
     }

     if (BitsPerPixel == 8)
     {
      bGriser2.Enabled = true;
      int W = bmp.Width, H = bmp.Height;
      int WScr = Screen.PrimaryScreen.Bounds.Width, HScr = Screen.PrimaryScreen.Bounds.Height;
      if (W < WScr && H < HScr) this.CenterToScreen();
      else this.DesktopLocation = new Point(50, 50);
     }
     else
     {
      MessageBox.Show("Ce programme ne grise que les images 8 bits");
      bGriser2.Enabled = false;
     }

     Invalidate();
    }
    catch (Exception exc)
    {
     MessageBox.Show(exc.Message, "Erreur systme");
     bmp = null;
    }
    zaPerformance.Text = "";
   }
  }

  private void Form1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
  {
   if (bmp != null) e.Graphics.DrawImage(bmp, 0, 80);
  }

  private unsafe void bGriser2_Click(object sender, System.EventArgs e)
  {
   DateTime t2, t1 = DateTime.Now;
   int W = bmp.Width, H = bmp.Height;
   Rectangle rc = new Rectangle(0, 0, W, H);
   PixelFormat pf = bmp.PixelFormat;
   BitmapData bmpData = bmp.LockBits(rc, ImageLockMode.ReadWrite, pf);

   if (BitsPerPixel == 8)
   {
    // Initialiser une copie de la palette
    ColorPalette pal = bmp.Palette;
    Color[] tb = new Color[256];
    bmp.Palette.Entries.CopyTo(tb, 0);

    byte* p, pDbut = (byte*)bmpData.Scan0;

    for (int li = 0; li < H; li++)
    {
     p = pDbut + li * W;
     for (int col = 0; col < W; col++)
     {
      byte n = *p;
      Color c = tb[n];
      int gris = (c.R + c.B + c.G) / 3;
      // Modifier la copie de la palette
      tb[n] = Color.FromArgb((byte)gris, (byte)gris, (byte)gris);
      p++;
     }
    }
    // Imposer la palette modifie
    for (int i = 0; i < 256; i++) pal.Entries.SetValue(tb[i], i);
    bmp.Palette = pal;
   }
   bmp.UnlockBits(bmpData);
   t2 = DateTime.Now;
   zaPerformance.Text = "Grisage en " + (t2 - t1).TotalMilliseconds + " millisecondes";
   Invalidate(false);

  }
 }
}